Index: app.c
===================================================================
RCS file: /usr/cvsroot/asterisk/app.c,v
retrieving revision 1.35
diff -u -r1.35 app.c
--- app.c	7 Dec 2004 20:38:43 -0000	1.35
+++ app.c	12 Dec 2004 15:52:35 -0000
@@ -27,6 +27,7 @@
 #include <asterisk/app.h>
 #include <asterisk/dsp.h>
 #include <asterisk/logger.h>
+#include <asterisk/indications.h>
 #include <asterisk/options.h>
 #include <asterisk/utils.h>
 #include <asterisk/lock.h>
@@ -35,6 +36,74 @@
 
 #define MAX_OTHER_FORMATS 10
 
+
+int ast_dtget(struct ast_channel *chan, char *collect, size_t size, int total, int to) {
+	struct tone_zone_sound *ts;
+	struct ast_frame *f;
+	time_t start,now;
+	int x=0;
+	int res=0;
+	int on=0;
+	int myto=0;
+
+	time(&start);
+	ast_set_write_format(chan, ast_best_codec(chan->nativeformats));
+    ast_set_read_format(chan, ast_best_codec(chan->nativeformats));
+	
+	ts = ast_get_indication_tone(chan->zone,"dial");
+    if (ts && ts->data[0]) {
+        res = ast_playtones_start(chan, 0, ts->data, 0);
+		on=1;
+	}
+	else 
+		ast_log(LOG_NOTICE,"Huh....? no dial?\n");
+
+	memset(collect,0,size);
+	for(x=0;x<total&&x<size;) {
+		time(&now);
+		myto = ast_strlen_zero(collect) ? 20 : to;
+		if((now - start) > myto) {
+			ast_playtones_stop(chan);
+			on=0;
+			break;
+		}
+		if(ast_waitfor(chan, 100) > -1) {
+			f = ast_read(chan);
+			if (f) {
+				if (f->frametype == AST_FRAME_DTMF) {
+					if(on) {
+						ast_playtones_stop(chan);
+						on=0;
+					}
+					if(f->subclass == '#') {
+						ast_playtones_stop(chan);
+                        on=0;
+						break;
+					}
+					else if(f->subclass == '*') {
+						memset(collect,0,size);
+						x=0;
+						res = ast_playtones_start(chan, 0, ts->data, 0);
+						on=1;
+					}
+					else {
+						collect[x++] = f->subclass;
+						time(&start);
+					}
+				}
+				ast_frfree(f);
+			}
+			else 
+				break;
+		}
+		else 
+			break;
+	}
+	
+	collect[x++] = '\0';
+	return x;
+}
+
 /* set timeout to 0 for "standard" timeouts. Set timeout to -1 for 
    "ludicrous time" (essentially never times out) */
 int ast_app_getdata(struct ast_channel *c, char *prompt, char *s, int maxlen, int timeout)
@@ -1069,4 +1138,17 @@
 	regfree(&regexbuf);
 
 	return count;
+}
+
+int ast_seperate_app_args(char *buf, char delim, char **array, int arraylen)
+{
+    int x = 0;
+    memset(array, 0, arraylen * sizeof(char));
+    for (array[x] = buf ; x < arraylen && array[x]; x++) {
+        if ((array[x+1] = strchr(array[x], delim))) {
+            *array[x+1] = '\0';
+            array[x+1]++;
+        }
+    }
+	return x;
 }
Index: include/asterisk/app.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/app.h,v
retrieving revision 1.17
diff -u -r1.17 app.h
--- include/asterisk/app.h	3 Oct 2004 21:18:27 -0000	1.17
+++ include/asterisk/app.h	12 Dec 2004 15:52:35 -0000
@@ -31,6 +31,10 @@
  *  is pressed during playback, it will immediately break out of the message and continue
  *  execution of your code.
  */
+
+/* present a dialtone and collect digits (DISA jr) */
+int ast_dtget(struct ast_channel *chan, char *collect, size_t size, int total, int to);
+
 extern int ast_app_getdata(struct ast_channel *c, char *prompt, char *s, int maxlen, int timeout);
 
 /* Full version with audiofd and controlfd.  NOTE: returns '2' on ctrlfd available, not '1' like other full functions */
@@ -81,6 +85,9 @@
 
 //! Get the current channel count of all groups that match the specified pattern and category.
 int ast_app_group_match_get_count(char *groupmatch, char *category);
+
+//! Parse a writable buffer seperated by a delimeter into an array of pointers to strings
+int ast_seperate_app_args(char *buf, char delim, char **array, int arraylen);
 
 #if defined(__cplusplus) || defined(c_plusplus)
 }
